Desktop application to select and configure a printer from a long list.

Use case: An university which has hundreds of SMB based printers
and students or staff that administrate some GNU/Linux desktops themselves.

 * Fetch list of printers (via SMB)
 * Fetch a multidevice printer description file.
 * Select printer from list (and select options for it)
 * Configure local CUPS or print out the needed commands.
 * Light and dark theme
 * Languages: English, German

![screenshot of main application window](docs/screenshots/main.png "Main Window")
![screenshot of main application window in dark theme](docs/screenshots/main_dark.png "Main Window - Dark Theme")


## License

This application as complete package is Free Software under
GNU Lesser General Public License v3.0 v >= 3.0
without warranty.

```
SPDX-License-Identifier: LGPL-3.0-or-later
SPDX-FileCopyrightText: 2020 Intevation GmbH <https://intevation.de>
Funded by: ETHZ
```

(May contain third party Free Software components under compatible licenses,
please see the README.md files and the files itself for more details.)

## Prebuild binaries
Packages for some GNU/Linux distributions:
https://software.opensuse.org/download/package?project=home:ethz&package=ethz-cups-config-app

## Building

Depends on [Qt](https://en.wikipedia.org/wiki/Qt_%28software%29)
5.12 <= version < 6

* [docs/NotesOpenSuse](docs/NotesOpenSuse.md)

### Ubuntu LTS 20.04
```sh
# build dependencies
apt-get install build-essential cmake mercurial \
qt5-default qttools5-dev qtdeclarative5-dev qtquickcontrols2-5-dev qml-module-qt-labs-settings
```

```sh
mkdir build
cd build
cmake ../
cmake --build .
```

## Deployment

Depends on the following being installed:
 * `smbclient` from [Samba](https://www.samba.org/)
 * A number of QtQuick modules.
 * cups and corresponding "filters" and "PPD" files.

### Ubuntu LTS 20.04
```sh
# runtime dependencies
apt-get install smbclient --no-install-recommends

apt-get install \
qml-module-qtquick2 \
qml-module-qtquick-controls \
qml-module-qtquick-controls2 \
qml-module-qtquick-dialogs \
qml-module-qt-labs-folderlistmodel \
qml-module-qt-labs-settings \
qml-module-qtquick-layouts \
qml-module-qtquick-window2
```