## credentials

The credentials for the SMB access to the printers will be
asked by cups/samba itself via a seperate GUI dialog,
offering the option to save them in the credential store
configured for the desktop (e.g. KWallet, Keyring). This is the best place
a desktop GNU/Linux distribution can offer.

However `smbclient` (in the tested versions) does not offer this option,
and to avoid being able to see the credentials in the process environment
(as variable or part of the command line arguments),
a restricted temporary file is used and deleted afterwards.


## external inputs

There are two external input files to the application.
They both are fetched using `smbclient`.
Transport security, in particular getting trustable versions of the files,
is thus delegated to `smbclient`.

A brief look in the documentation shows that SMBv3 has cryptographic
options and samba (the package providing smbclient) uses gnutls
and its TLS capabilites to check certificates by default in principle.
The application currently uses the `--encrypt` option to enforece encryption during smb file transfer.

### printers configuration file

Its contents will be used as options to a call of `lpadmin`.
To avoid shell escape injection, the https://doc.qt.io/qt-5/qprocess.html
class is used, which calls the binary directly and does **not** use
a shell.

### multibrand PPD file

The printer description file is saved and
given to `lpadmin` to be copied and installed by CUPS.

The extentions to PPD by CUPS https://www.cups.org/doc/spec-ppd.html
allow to specify filter applications with the options
`cupsFilter`, `cupsFilter2`, `cupsPreFilter`. According to the
documentation https://www.cups.org/doc/man-cups-files.conf.html
the filters will be searched on a fixed file path, offering some protection
against specifying arbitray executables.
