import QtQuick 2.12
import QtQuick.Controls 2.12
import QtQuick.Dialogs 1.1
import QtQuick.Layouts 1.3
import QtQuick.Window 2.12

//Dialog showing errors
Dialog {
    x: 100
    y: 100
    modal: true
    width: 425
    height: 200
    closePolicy: Popup.NoAutoClose
    property var contentLeftMargin: 10

    function setContent(content) {
        errorContent.text = content;
    }
    Text {
        id: errorPrefix
        text: qsTr("An error occured during application startup:")
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.topMargin: 10
        anchors.leftMargin: contentLeftMargin
        font.pixelSize: 12
    }

    Text {
        id: errorContent
        text: ""
        anchors.top: errorPrefix.bottom
        anchors.left: parent.left
        anchors.topMargin: 10
        anchors.leftMargin: contentLeftMargin
        font.pixelSize: 12
    }

    Text {
        id: errorPostfix
        width: parent.width - contentLeftMargin
        text: qsTr("Please ensure that both smbclient and lpadmin are available on your system and restart the application.")
        wrapMode: Text.WordWrap
        anchors.top: errorContent.bottom
        anchors.left: parent.left
        anchors.topMargin: 10
        anchors.leftMargin: contentLeftMargin
        font.pixelSize: 12
    }

    standardButtons: Dialog.Cancel
    Component.onCompleted: {
        standardButton(Dialog.Cancel).text = qsTr("Exit")
    }

    onRejected: {
        Qt.quit()
    }
}
