import QtQuick 2.12
import QtQuick.Window 2.12
import QtQuick.Controls 2.12
import QtQuick.Layouts 1.3

Button {
    height: 45
    width: 20
    flat: true
    anchors.margins: 0

    property var mode: available_printers_model.SORT_NONE;
    property var column: -1;

    Image {
        id: ascIcon
        source: styleUtil.getIconPath("triangle.svg")
        height: 15
        width: 15
        anchors.top: parent.top
        anchors.topMargin: 7
        anchors.left: parent.left
        anchors.leftMargin: 2
        anchors.right: parent.right
        anchors.rightMargin: 2
        visible: mode === available_printers_model.SORT_NONE || mode === available_printers_model.SORT_ASC

    }
    Image {
        id: descIcon
        source: styleUtil.getIconPath("triangle.svg")
        height: 15
        width: 15
        rotation: 180
        anchors.top: ascIcon.bottom
        anchors.margins: 0
        anchors.left: ascIcon.left
        anchors.leftMargin: 0
        anchors.right: ascIcon.right
        anchors.rightMargin: 0
        visible: mode === available_printers_model.SORT_NONE || mode === available_printers_model.SORT_DSC
    }

    function toggle() {
        switch (mode) {
        case available_printers_model.SORT_NONE:
            mode = available_printers_model.SORT_DSC;
            break;
        case available_printers_model.SORT_ASC:
            mode = available_printers_model.SORT_NONE;
            break;
        case available_printers_model.SORT_DSC:
            mode = available_printers_model.SORT_ASC;
            break;
        }
        available_printers_model.sortTable(column, mode);
    }
}
